"""
    MoinMoin - Render as DocBook action - redirects to the DocBook formatter

    @copyright: 2005 MoinMoin:AlexanderSchremmer
    @license: GNU GPL, see COPYING for details.
"""

from document.formatter.wiki.Page import Page
from document.formatter.wiki.util import MoinMoinNoFooter

def execute(pagename, request):
    url = Page(request, pagename).url(request, {'action': 'format',
                                                'mimetype': 'xml/docbook'}, 0)
    request.http_redirect(url)
    raise MoinMoinNoFooter
