/* etc function begin */
function setRunning (obj)
{
	obj.setOpacity(0.3);
	var __img = document.createElement("IMG");
	__img.src = "/__media__/image/running.gif";
	var __style = {
		position: "fixed",
		top: obj.offsetTop + "px",
		left: obj.offsetLeft + (obj.offsetWidth / 2) + "px",
	}
	__img.setStyle(__style);
	obj.parentNode.appendChild(__img);

	return __img;
}

function removeRunning (img)
{
	var __parent = img.parentNode;
	__parent.removeChild(img);

	return;
}

/* etc function end */

/* set layout */
function setLayout ()
{
	$("footer").style.left = $("content").offsetLeft + "px";
	$("content").style.height = $("footer").offsetTop - $("content").offsetTop + "px";

	$("block_pager").style.width = document.body.offsetWidth + "px";
	//$("block_pager-ul").style.width = document.body.offsetWidth + "px";

	return;
}

function setLayoutTagListLabel ()
{
	var __id_block_content = "view_channels-content";
	var __id_block_labels =
		"view_channels-content-tag_list-labels";

	var __height = $(__id_block_content).offsetHeight;
	var __top = $(__id_block_content).offsetTop;
	var __top_labels = __top + $(__id_block_labels).offsetTop;

	var __height_for_labels = (__top + __height) - __top_labels;

	if ($(__id_block_labels).offsetHeight > (__height - 100))
	{
		$(__id_block_labels).style.height = __height_for_labels + "px";
	}
}

function setLayoutSearch ()
{
	var __height_header = $("search-header").offsetHeight;
	var __height_page = $("search-header").parentNode.offsetHeight;
	$("search-content").style.height = (__height_page - __height_header - 10) + "px";
}

function setLayoutMemo ()
{
	var __height_header = $("memo-header").offsetHeight;
	var __height_page = $("memo-header").parentNode.offsetHeight;
	var __width_page = $("memo-header").parentNode.offsetWidth;
	var __width_sub_content = $("memo-sub_content").offsetWidth + 50;
	var __height_content = (__height_page - __height_header - 10);

	$("memo-content").style.width = (__width_page - __width_sub_content) + "px";
	$("memo-content").style.height = __height_content + "px";

	$("memo-sub_content").style.height = __height_content + "px";
	$("memo-sub_content-content").style.height =
		__height_content - ($("memo-sub_content-header").offsetHeight) - 10 + "px";

	$("memo-sub_content-header-keyword").style.width =
		($("memo-sub_content-content").offsetWidth - 20) + "px";
}

/* API */

/* page begin */
/*
// it's examples
*/
function showPageHelp ()
{
	new Ajax.Request(
		"/__media__/html/help.html",
		{
			onComplete: function(request)
			{
				__PAGE__.addPage(
					"help",
					request.responseText,
					{
						label: "<img src=\"/__media__/image/x-20.png\">Help",
						id_scrollable: "help-content"
					}
				);
			}
		}
	);

	return false;
}

function showPageAboutUs ()
{
	new Ajax.Request(
		"/__media__/html/about_us.html",
		{
			onComplete: function(request)
			{
				__PAGE__.addPage(
					"about_us",
					request.responseText,
					{
						label: "<img src=\"/__media__/image/x-20.png\">About Us",
						id_scrollable: "about_us"
					}
				);
			}
		}
	);

	return false;
}

function showPageChannel (id_channel, label_channel)
{
	new Ajax.Request(
		"/api/channel/viewChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					__PAGE__.addPage(
						"channel-" + id_channel,
						request.responseText,
	{
		label: "<img src='/__media__/image/channel-20.png'>" + label_channel,
		id_scrollable: "view_channel-" + id_channel + "-content"
	}
					);
				}
			}
		}
	);
	return;
}

function getPageMemoChannelEntry (id_channel, id_entry, label)
{
	__PAGE__.addPage(
		"memo-channel_entry-" + id_channel + "." + id_entry,
		"findeme",
		{label: "<img src='/__media__/image/memo_20.png'>" + label}
	);
	return;
}

function getPageImportOPML ()
{
	new Ajax.Request(
		"/api/channel/getPageImportOPML/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					__PAGE__.addPage(
						"import_opml",
						request.responseText,
						{label: "Import OPML"}
					);
				}
			}
		}
	);
	return;
}
function getPageFrontpage ()
{
	new Ajax.Request(
		"/api/channel/getPageFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					__PAGE__.addPage(
						"frontpage",
						request.responseText,
						{label: "Frontpage"}
					);
				}
			}
		}
	);
	return;
}
/* page end */

/* channel begin */
function updateFrontpage ()
{
	new Ajax.Request(
		"/api/channel/getPageFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update("page-frontpage", request.responseText);
					__PAGE__.showPage("frontpage");
					__PAGE__.fire("frontpage");
				}
			}
		}
	);
	return;
}

function updateAddChannel ()
{
	new Ajax.Request(
		"/api/channel/getPageAddChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					__PAGE__.addPage(
						"add_channel",
						request.responseText,
						{label: "Add Channel"}
					);
				}
			}
		}
	);
	return;
}

function updatePreference ()
{
	new Ajax.Request(
		"/api/user/preference/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update("page-preference", request.responseText);
					__PAGE__.showPage("preference");
					__PAGE__.fire("preference");
				}
			}
		}
	);
	return;
}

function updateSearch ()
{
	new Ajax.Request(
		"/api/channel/getPageSearch/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update("page-search", request.responseText);
					__PAGE__.showPage("search");
					__PAGE__.fire("search");
				}
			}
		}
	);
	return;
}

function updateViewChannels ()
{
	new Ajax.Request(
		"/api/channel/getPageViewChannels/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update("page-channel", request.responseText);
					//__PAGE__.showPage("channel");
					__PAGE__.fire("channel");
				}
			}
		}
	);
	return;
}

function updateMemo ()
{
	new Ajax.Request(
		"/api/memo/getPage/",
		{
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update("page-memo", request.responseText);
					__PAGE__.showPage("memo");
					__PAGE__.fire("memo");
				}
			}
		}
	);
	return;
}

function updateEntriesFrontpage (options)
{
	var __options = {
		offset: 0,
		show_starred: false
	}

	Object.extend(__options, options || {});
	var __options = $H(__options);

	new Ajax.Request(
		"/api/channel/getEntriesFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __options.toQueryString(),
			onLoading: function(e)
			{
				new Effect.Progress("pager-frontpage");
			},
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update(
						"frontpage-content-script",
						request.responseText
					);
				}
			}

		}
	);
	return;
}

function updatePagerInFrontpage (offsets)
{
	// store offsets
	$("frontpage-header-offset-prev").value = offsets.prev;
	$("frontpage-header-offset-next").value = offsets.next;
	$("frontpage-header-offset-current").value = offsets.current;

	var __id_last_prev = "frontpage-header-pager-last_prev";
	var __id_prev = "frontpage-header-pager-prev";
	var __id_next = "frontpage-header-pager-next";
	var __id_last_next = "frontpage-header-pager-last_next";

	if (offsets.prev == -1)
	{
		$(__id_last_prev).className = "inactive";
		$(__id_last_prev).onclick = dummy;
	} else {
		$(__id_last_prev).className = "active";
		$(__id_last_prev).onclick = function(e)
		{
			updateEntriesFrontpage({offset: 0});
		}
	}

	if (offsets.next == 0)
	{
		$(__id_last_next).className = "inactive";
		$(__id_last_next).onclick = dummy;
	} else {
		$(__id_last_next).className = "active";
		$(__id_last_next).onclick = function(e)
		{
			updateEntriesFrontpage({offset: -1});
		}

	}

	if (offsets.prev != -1)
	{
		$(__id_prev).className = "active";
		$(__id_prev).onclick = function(e)
		{
			updateEntriesFrontpage({offset: offsets.prev});
		}
	} else {
		$(__id_prev).className = "inactive";
		$(__id_prev).onclick = dummy;
	}

	if (offsets.next)
	{
		$(__id_next).className = "active";
		$(__id_next).onclick = function(e)
		{
			updateEntriesFrontpage({offset: offsets.next});
		}

	} else {
		$(__id_next).className = "inactive";
		$(__id_next).onclick = dummy;
	}

}

function setAllPostInthisPageAsSkip (callback)
{
	var __children = findChildren("frontpage-content", "DIV");
	var __args = $(__children).map(function(ele) {
		if (! ele.id) return;
		if (ele.className == "entry_read") return;
		if (ele.className == "entry_skip") return;

		if (! callback)
		{
			markAsSkip(ele.id);
		}

		var __id = ele.id.replace(/^entry-[a-z-0-9][a-z0-9]*-/g, "");
		return "uid=" + encodeURIComponent(__id);
	}).join("&");

	new Ajax.Request(
		"/api/channel/setAsSkipMany/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __args,
			onComplete: function(request)
			{
				if (callback) callback();
			}
		}
	);
	return false;
}


function setSkipAllEntryInFrontpage ()
{
	var grid = __GRIDS__.get("grid-frontpage");
	var __children = grid.findElementByUIDField(grid.fields[2]);
	var __b = $A();

	var __reg = /^entry-[a-z-0-9][a-z0-9]*-/g;
	var __uids = $A();
	$A(__children).each(
		function(l)
		{
			__uids.push(
				"uid=" + encodeURIComponent(l.childNodes[0].id.replace(__reg, ""))
			);
		}
	);

	new Ajax.Request(
		"/api/channel/setAsSkipMany/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __uids.join("&"),
			onComplete: function(request)
			{
				updateEntriesFrontpage({offsets: 0});
			}
		}
	);

	return;
}

function setAsRead (id_channel, id_entry)
{
	new Ajax.Request(
		"/api/channel/setAsReadChannelEntry/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel + "&id_entry=" + id_entry,
			onComplete: function(request)
			{
			}
		}
	);
}

function markAsRead (id_element)
{
	$(id_element).className = "entry_read";
}

function updateEntriesViewChannel (id_channel, options)
{
	var __options = {
		offset: 0,
		show_starred: false
	}

	Object.extend(__options, options || {});
	var __options = $H(__options);

	new Ajax.Request(
		"/api/channel/getEntriesViewChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __options.toQueryString() + "&id_channel=" + id_channel,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update(
						"view_channel-" + id_channel + "-content-script",
						request.responseText
					);
				}
			}
		}
	);
	return;
}

function updatePagerInViewChannel (id_channel, offsets)
{
	// store offsets
	$("view_channel-" + id_channel + "-header-offset-prev").value = offsets.prev;
	$("view_channel-" + id_channel + "-header-offset-next").value = offsets.next;
	$("view_channel-" + id_channel + "-header-offset-current").value =
		offsets["current"];

	var __id_last_prev = "view_channel-" + id_channel + "-header-pager-last_prev";
	var __id_prev = "view_channel-" + id_channel + "-header-pager-prev";
	var __id_next = "view_channel-" + id_channel + "-header-pager-next";
	var __id_last_next = "view_channel-" + id_channel + "-header-pager-last_next";

	if (offsets.prev == -1)
	{
		$(__id_last_prev).className = "inactive";
		$(__id_last_prev).onclick = dummy;
	} else {
		$(__id_last_prev).className = "active";
		$(__id_last_prev).onclick = function(e)
		{
			updateEntriesViewChannel(
				id_channel,
				{
					offset: 0,
					id_channel: id_channel
				}
			);
		}
	}

	if (offsets.next == 0)
	{
		$(__id_last_next).className = "inactive";
		$(__id_last_next).onclick = dummy;
	} else {
		$(__id_last_next).className = "active";
		$(__id_last_next).onclick = function(e)
		{
			updateEntriesViewChannel(
				id_channel,
				{
					offset: -1,
					id_channel: id_channel
				}
			);
		}

	}

	if (offsets.prev != -1)
	{
		$(__id_prev).className = "active";
		$(__id_prev).onclick = function(e)
		{
			updateEntriesViewChannel(
				id_channel,
				{
					offset: offsets.prev,
					id_channel: id_channel
				}
			);

		}
	} else {
		$(__id_prev).className = "inactive";
		$(__id_prev).onclick = dummy;
	}

	if (offsets.next)
	{
		$(__id_next).className = "active";
		$(__id_next).onclick = function(e)
		{
			updateEntriesViewChannel(
				id_channel,
				{
					offset: offsets.next,
					id_channel: id_channel
				}
			);
		}

	} else {
		$(__id_next).className = "inactive";
		$(__id_next).onclick = dummy;
	}

}

function changeTermOfEntriesInFrontpage (t)
{
	new Ajax.Request(
		"/api/channel/changeTermOfEntriesInFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "term=" + t,
			onComplete: function(request)
			{
				updateEntriesFrontpage({offset: 0});
			}
		}
	);

	return;
}

function changeTermOfEntriesInViewChannel (id_channel, t)
{
	new Ajax.Request(
		"/api/channel/changeTermOfEntriesInViewChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "term=" + t + "&id_channel=" + id_channel,
			onComplete: function(request)
			{
				updateEntriesViewChannel(id_channel, {offset: 0});
			}
		}
	);
}

function removeThisChannelEntriesFromFrontpage (id_channel, value, callback)
{
	new Ajax.Request(
		"/api/channel/removeChannelFromFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel + "&value=" + value,
			onComplete: function(request)
			{
				if (callback) callback(id_channel);
			}
		}
	);

}

function removeThisChannelEntriesFromFrontpageInFrontpage (id_channel)
{
	var callback = function(id_channel)
	{
		var __reg = new RegExp("^entry-" + id_channel + "-", "g");
		var __children = findChildren("frontpage-content", "DIV");
		if (__children.length > 0)
		{
			$A(__children).each(
				function(i)
				{
					if (i.id.search(__reg) == -1)
					{
						return;
					} else {
						i.style.backgroundColor = "#b7c6b6";
					}
				}
			);
		}

	}

	removeThisChannelEntriesFromFrontpage(id_channel, "false", callback);
}

function getChannelLabels ()
{
	var __id_labels_in_header = "view_channels-header-labels";
	// find out siblings in header.
	var __labels_in_header = findChildren(__id_labels_in_header, "LI");

	// make pool
	var __pool = new Array();
	$A(__labels_in_header).each(
		function(i)
		{
			__id_label = parseInt(i.id.replace("label-", ""));
			if (__id_label)
			{
				__pool.push(__id_label)
			}
		}
	);

	return __pool;
}

function updateViewChannelByLabel (id_label, name_label)
{
	var __id_labels_in_header = "view_channels-header-labels";
	var __id_labels_in_header_add_channel = "add_channel-labels-list";

	var __list_root = [null, "all", "uncategorized"];
	var __id_tag_list =
		"view_channels-content-tag_list-labels";

	var __query_labels = "";
	if ($A(__list_root).indexOf(id_label) != -1)
	{
		Element.update(__id_labels_in_header, "");

		if (id_label == "uncategorized")
		{
			__query_labels = "id_label=uncategorized";
		}
	} else {
		__pool = getChannelLabels();

		// append labels in header.
		if (__pool.indexOf(id_label) == -1 && name_label)
		{
			var __li_label_in_header = document.createElement("LI");
			var __li_label_in_header_add_channel = document.createElement("LI");
			__li_label_in_header.className = "li_none";
			__li_label_in_header_add_channel.className = "li_none";

			__li_label_in_header.innerHTML = name_label;
			__li_label_in_header.id = "label-" + id_label;
			__li_label_in_header.title = "Delete this label";

			__li_label_in_header_add_channel.innerHTML = name_label;
			__li_label_in_header_add_channel.id = "label-add_channel-" + id_label;

			var __img_label_in_header = document.createElement("IMG");
			__img_label_in_header.src = "/__media__/image/minus_15.png"
			__li_label_in_header.appendChild(__img_label_in_header);

			__li_label_in_header.onclick = function(e)
			{
				var this_element = this;
				new Effect.Fade(
					this_element.id,
					{
						afterFinish: function(e)
						{
							// remove itself.updateViewChannelByLabel
							this_element.parentNode.removeChild(this_element);
							updateViewChannelByLabel("", "");

							// remove from add_chanenl labels
							if (isExists(__id_labels_in_header_add_channel))
							{
								__id_label = parseInt(this_element.id.replace("label-", ""));
								$(__id_labels_in_header_add_channel).removeChild(
									$("label-add_channel-" + __id_label)
								);
							}
						}
					}
				);
				return false;
			}

			$(__id_labels_in_header).appendChild(__li_label_in_header);

			/* if add channel page is showed, add label in add channel page */
			if (isExists(__id_labels_in_header_add_channel))
			{
				$(__id_labels_in_header_add_channel).appendChild(
					__li_label_in_header_add_channel);
			}
		}

		var __labels_in_header = findChildren(__id_labels_in_header, "LI");
		__query_labels = $A(__labels_in_header).map(
			function(i)
			{
				if (! i.id) return;
				return "id_label=" + encodeURIComponent(i.id.replace("label-", ""));
			}
		).join("&");
	}

	// generate channel labels.
	new Ajax.Request(
		"/api/channel/getChannelLabelList/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __query_labels,
			onLoading: function(e)
			{
				new Effect.Progress("view_channels-content-channel_list");
			},
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update(__id_tag_list, request.responseText);

					// generate channel list.
					new Ajax.Request(
						"/api/channel/getChannelList/",
						{
							asyncronous: true,
							evalScripts: true,
							parameters: __query_labels,
							onComplete: function(request)
							{
	Element.update(
		"view_channels-content-channel_list",
		request.responseText
	);
	__PAGE__.reset("channel");
	setLayoutViewChannels();
							}
						}
					);

				}
			}
		}
	);

}

function updateSortableChannelLabel (id_element, id_channel)
{
	new Effect.Appear("trash");
	Sortable.create(
		id_element,
		{
			constraint: false,
			dropOnEmpty: true,
			format: /^[^\-]*\-(.*)$/,
			onUpdate:function()
			{
				var __d = Sortable.serialize(
					this.element.id,
					{
						name: "labels"
					}
				);

				/* update sequence */
				new Ajax.Request(
					"/api/channel/setLabelSequence/",
					{
						asyncronous: true,
						evalScripts: true,
						parameters: __d + "&id_channel=" + id_channel,
						onComplete: function(request)
						{
							//alert(__d);
						}
					}
				);
			}
		}
	);
}

function removeChannelInViewChannels (id_channel)
{
	var __template_id_channel =
		"view_channels-content-channel_list-channel-title-";
	var __id_block_channel_list =
		"view_channels-content-channel_list";

	var __id_block_channel =
		"view_channels-content-channel_list-channel-" +
			id_channel;

	// remote-call 'remove label'
	new Ajax.Request(
		"/api/channel/removeChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					// fade out element
					new Effect.Fade(
						__id_block_channel,
						{
							duration: 0.2,
							afterFinish: function(e)
							{
						$(__id_block_channel_list).removeChild($(__id_block_channel));
							}
						}
					);
				}
			}
		}
	);

}

function checkNewEntryFrontpage (timeout)
{
	var __timeout = 10000;
	setTimeout(
		function(e)
		{
			new Ajax.Request(
				"/api/channel/checkNewEntryFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							$("pager-frontpage").className = "newInFrontpage";
							/*
							new Effect.Pulsate(
								"pager-frontpage",
								{
									duration: __timeout / 1000
								}
							);
							*/
						} else {
							$("pager-frontpage").className = "nothingInFrontpage";
							Element.setOpacity("pager-frontpage", 1.0);
						}
						checkNewEntryFrontpage(__timeout);
					}
				}
			);
		},
		timeout
	);
}

function onClickAddNewLabelInChannel (id_channel)
{

	var __id = "view_channels-content-channel_list-channel-info-labels-sortable-" + id_channel;
	var __id_input = id_channel + "-new";
	var __label_li = document.createElement("LI");
	__label_li.className = "input";
	var __label_input = document.createElement("INPUT");
	__label_input.id = __id_input;
	__label_input.className = "label";
	__label_li.appendChild(__label_input);

	$(__id).appendChild(__label_li);
	__label_input.focus();
	__label_input.onkeypress = function(e)
	{
		var __key = null;
		if (e.target) // NS
		{
			__key = e.keyCode;
		} else if (e.srcElement) { // IE
			__key = e.charCode;
		}

		if (__key == 13)
		{
			this.blur();
			return false;
		} else if (__key == 27) {
			new Effect.Fade(
				__label_li,
				{
					duration: 0.5,
					afterFinish: function(e)
					{
						$(__id).removeChild(__label_li);
					}
				}
			);
			return false;
		} else {
			return true;
		}
	}
	__label_input.onblur = function(e)
	{
		var this_element = this;
		var __label_li = this.parentNode;
		var __value = $(__id_input).value;
		if (! trimString(__value))
		{
			new Effect.Fade(
				this_element.parentNode,
				{
					duration: 0.5,
					afterFinish: function(e)
					{
						$(__id).removeChild(__label_li);
					}
				}
			);
			return;
		}

		new Ajax.Request(
			"/api/channel/setLabel/",
			{
				asyncronous: true,
				evalScripts: true,
				parameters: "id_channel=" + id_channel + "&label=" + encodeURIComponent(__value),
				onComplete: function(request)
				{
					if (request.status != 200) return;
					new Effect.Fade(
						__label_li,
						{
							duration: 0.5,
							afterFinish: function(e)
							{
								var __id_label = request.responseText;

								$(__id).removeChild(__label_li);

								// create new one.
								var __label_li0 = document.createElement("LI");
								__label_li0.style.display = "none";
								__label_li0.className = "label_one";
								__label_li0.innerHTML = __value;
								__label_li0.id = "label-" + id_channel + "." + __id_label;
								$(__id).appendChild(__label_li0);

								new Effect.Appear(
									__label_li0,
									{
										duration: 0.5,
										afterFinish: function(e)
										{

											var __children = findChildren(__id, "LI");
											// add to label list
											if (__children.length == 1)
											{
												// check whether __id_label exists or not.

	var __id_new = "view_channels-content-tag_list-labels-label_one-" + __id_label;
												if (! isExists(__id_new))
												{
	// create new one
	var __id_labels = "view_channels-content-tag_list-labels"
	var __label_li = document.createElement("LI");
	__label_li.id = __id_new;
	__label_li.className = "li_none";
	__label_li.innerHTML = __value;
	__label_li.onload = function(e)
	{
		this.classNameOrig = this.className;
		return false;
	}
	__label_li.onmouseover = function(e)
	{
		this.classNameOrig = this.className;
		this.className ="hover";
		return false;
	}
	__label_li.onmouseout = function(e)
	{
		this.className = this.classNameOrig;
		return false;
	}
	__label_li.onclick = function(e)
	{
		onClickChannelLabel(this, __id_label);
		return false;
	}
													$(__id_labels).appendChild(__label_li);
												}
											}

	if (__ID_CURRENT_SORTABLES_IN_VIEW_CHANNELS__ &&
			$(__ID_CURRENT_SORTABLES_IN_VIEW_CHANNELS__).className == "")
	{
		return false;
	}

											updateSortableChannelLabel(__id, id_channel);
										}
									}
								);
							}
						}
					);
				}
			}
		);

	}

	return;
}

function setStarInGrid (obj_img, id_channel, id_entry)
{
	var __img_src = "http://localhost:8000/__media__/image/star-20.png";
	var __value = 1;
	if (obj_img.getAttribute("is_star") == "1")
	{
		__value = 0;
		var __img_src = "http://localhost:8000/__media__/image/unstar-20.png";
	}

	new Ajax.Request(
		"/api/channel/setAsStarChannelEntry/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "value=" + __value +
				"&id_channel=" + id_channel +
				"&id_entry=" + id_entry,
			onComplete: function(request)
			{
				obj_img.setAttribute("is_star", __value);
				obj_img.src = __img_src;
				obj_img.parentNode.setAttribute("column_value", __value);
			}
		}
	);
}


function setStar (obj_img, id_channel, id_entry)
{
	var __img_reg = /\/__media__\/image\/star.png/g;
	var __value = 0;
	var __img_src = "/__media__/image/unstar.png";
	if (obj_img.src.search(__img_reg) == -1)
	{
		var __value = 1;
		var __img_src = "/__media__/image/star.png/";
	}

	new Ajax.Request(
		"/api/channel/setAsStarChannelEntry/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "value=" + __value +
				"&id_channel=" + id_channel +
				"&id_entry=" + id_entry,
			onComplete: function(request)
			{
				obj_img.src = __img_src;
			}
		}
	);
}

function addChannelInViewChannel (obj, id_channel)
{
	var __img = setRunning(obj);

	new Ajax.Request(
		"/api/channel/addChannelKnown/",
		{
			asycronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					setTimeout(
						function(e)
						{
							var __parent = obj.parentNode;
							__parent.removeChild(obj);
							removeRunning(__img);
						},
						1000
					);
				} else {
					removeRunning(__img);
				}
			}
		}
	);
}

/* channel end */

/* add channel begin */
function submitAddChannelGetCandidate ()
{
	Element.update("add_channel-msg-info", "");
	Element.update("add_channel-msg-error", "");
	Element.hide("add_channel-msg-info");
	Element.hide("add_channel-msg-error");
	Element.hide("add_channel-result");
	Element.show("add_channel-updating");

	var __s = trimString($("add_channel-input").value);
	if (! __s)
	{
		Element.update("add_channel-msg-error", "Enter string.");
		Element.show("add_channel-msg-error");
		Element.hide("add_channel-updating");
		return false;
	}

	/* valid url */
	new Ajax.Request(
		"/api/etc/validateUrl/",
		{
			parameters: "url=" + encodeURIComponent(__s),
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status != 200)
				{
					Element.update(
						"add_channel-msg-error",
						"The url invalid url, check it."
					);
					Element.show("add_channel-msg-error");
					Element.hide("add_channel-updating");
					$("add_channel-input").select();
				} else {
					new Ajax.Request(
						"/api/channel/getRSSUrlCandidate/",
						{
							parameters: "href=" + encodeURIComponent(request.responseText),
							asyncronous: true,
							evalScripts: true,
							onComplete: function(request)
							{
								if (request.status == 200)
								{
									Element.show("add_channel-result");
									Element.update(
										"add_channel-result-content",
											request.responseText);
									Element.hide("add_channel-updating");
								} else if (request.status == 600) {
									Element.hide("add_channel-result");
									Element.hide("add_channel-updating");
									Element.update(
										"add_channel-msg-info",
										"Already added.");
									Element.show("add_channel-msg-info");
								} else {
									Element.hide("add_channel-updating");
								}
							}
						}
					);
					Element.update("add_channel-msg-error", "");
					Element.hide("add_channel-msg-error");
					Element.update("add_channel-msg-info", "");
					Element.hide("add_channel-msg-info");
				}
			}
		}
	);

	return;
}

function submitAddChannelAdd (element_form)
{
	var __input_list_selected = element_form.block_content_add_channel_selected;
	var __a = new Array();
	if (__input_list_selected.length)
	{
		for (var i = 0; __input_list_selected.length > i; i++)
		{
			var __value = __input_list_selected[i].value;
			if (__value) __a.push(__value);
		}
	} else {
		__a.push(__input_list_selected.value);
	}

	if (__a.length < 1)
	{
		Element.update("add_channel-msg-error", "At least select one url.");
		return false;
	} else {
		/* make query string */
		var __hrefs = new Array();
		$A(__a).each(
			function(i)
			{
				__hrefs.push("hrefs=" + encodeURIComponent(i));
			}
		);

		/* get labels */
		var __id_labels = $("addChannel-result-id_labels").value;

		new Ajax.Request(
			"/api/channel/addChannel/",
			{
				asyncronous: true,
				evalScripts: true,
				parameters: __hrefs.join("&") + "&id_labels=" + __id_labels,
				onLoading: function (e)
				{
					Element.show("add_channel-adding");
				},
				onComplete: function(request)
				{
					Element.hide("add_channel-adding");
					if (request.status == 200)
					{
						$("add_channel-input").value = "";
						new Effect.Fade(
							"add_channel-result",
							{
								afterFinish: function(e)
								{
									Element.update(
										"add_channel-msg-info", "Successfully added.");
									Element.show("add_channel-msg-info");
								}
							}
						);
					} else {
						Element.update("add_channel-msg-error",
							"Failed to add this channels. Try again.");
						Element.show("add_channel-msg-errro");
					}
					setTimeout(
						function(e)
						{
							Element.hide("add_channel-adding");
							//alert(request.responseText.parseJSON());
						},
						10
					);
				}
			}
		);
	}

	return;
}

/* add channel end */

/* search begin */
function addSearchCondition (options)
{
	var __options = {
		"selected" : null,
		"value" : ""
	}

	var __reg_key = new RegExp("^__", "g");
	var __options_selected = {
		__title : "Title",
		__summary : "Summary",
		__author : "Author",
		/*
		__timePublished : "Published time",
		*/
		__isStar : "Starred?",

		id_keyword : __uid + "-keyword",
		id_isStar : __uid + "-isStar",
		id_isStar_text : __uid + "-isStar-text",
		cb_default : function(obj_li)
		{
			if ($(this.id_isStar).style.display != "none")
			{
				var __self = this;
				new Effect.Fade(
					__self.id_isStar,
					{
						duration: 0.5,
						beforeFinish: function(e)
						{
							Element.hide(__self.id_isStar_text);
						},
						afterFinish: function(e)
						{
							new Effect.Appear(__self.id_keyword, {duration: 0.5, });
						}
					}
				);
			}
		},
		cb_isStar : function(obj_li)
		{
			if ($(this.id_keyword).style.display != "none")
			{
				var __self = this;
				new Effect.Fade(
					__self.id_keyword,
					{
						duration: 0.5,
						afterFinish: function(e)
						{
							new Effect.Appear(
							__self.id_isStar,
								{
									duration: 0.5,
									afterSetup: function(e)
									{
										Element.show(__self.id_isStar_text);
									}

								}
							);
						}
					}
				);
			}
		}
	}

	Object.extend(__options, options || {});

	var __children = findChildren("search-conditions", "LI");

	// prevent duplicated search conditions
	var __ids = $A();
	for (var i = 0; i < __children.length; i++)
	{
		var __s = $("condition-" + i + "-option");
		if (! __s) continue;
		__ids.push(__s.value);
	}

	__key = null;
	__keys = $H(__options_selected).keys();
	for (var i = 0; i < __keys.length; i++)
	{
		if (__keys[i].search(__reg_key) == -1) continue;
		var __k = __keys[i].replace(__reg_key, "");
		if (__ids.indexOf(__k) == -1)
		{
			__key = __k;
			break;
		}
	}

	if (! __key)
	{
		return false;
	} else {
		__options["selected"] = __key;
	}

	// check the number of conditions, LI element
	var __uid = "condition-" + __children.length;

	var __li = document.createElement("LI");
	__li.style.display = "none";
	__li.id = __uid;
	__li.className = "condition";
	var __input_keyword = document.createElement("INPUT");
	__input_keyword.id = __uid + "-keyword";
	__input_keyword.type = "text";
	if (__options["selected"] != "isStar")
	{
		__input_keyword.value = __options["value"];
	}

	var __input_isStar = document.createElement("INPUT");
	__input_isStar.style.display = "none";
	__input_isStar.id = __uid + "-isStar";
	__input_isStar.type = "checkbox";
	__input_isStar.checked = true;

	var __input_isStar_text = document.createElement("SPAN");
	__input_isStar_text.innerHTML = "Only starred entry?"
	__input_isStar_text.id = __uid + "-isStar-text";
	__input_isStar_text.style.display = "none";

	var __image_minus = document.createElement("IMG");
	__image_minus.src = "/__media__/image/minus-15.png";
	__image_minus.style.cursor = "pointer";
	__image_minus.onclick = function(e)
	{
		var __self = this;
		new Effect.Fade(
			__self.parentNode,
			{
				duration: 0.5,
				afterFinish: function(e)
				{
					$("search-conditions").removeChild(__self.parentNode);

					// re-enable search-keyword-main
					setTimeout(
						function(e)
						{
							var __children = findChildren("search-conditions", "LI");
							if (__children.length < 1)
							{
								$("search-keyword-main").disabled = false;
								$("search-keyword-main").focus();
								Element.hide("search-conditions");

							}
							setLayoutSearch();
						},
						100
					);
				}
			}
		);
	}

	var __select = document.createElement("SELECT");
	__select.id = __uid + "-option";
	var __n = 0;
	for (var __k in __options_selected)
	{
		if (__k.search(__reg_key) == -1) continue;

		var __key = __k.replace(__reg_key, "");
		var __option = new Option(__options_selected[__k], __key);

		if (__options["selected"] == __key)
		{
			__option.selected = true;
		}
		__select.options[__n] = __option;
		__n += 1;
	}

	__select.onchange = function(e)
	{
		if (__options_selected["cb_" + this.value])
		{
			__options_selected["cb_" + this.value]();
		} else {
			__options_selected["cb_default"]();
		}
	}

	__li.appendChild(__select);
	__li.appendChild(__input_isStar);
	__li.appendChild(__input_isStar_text);
	__li.appendChild(__input_keyword);
	__li.appendChild(__image_minus);

	$("search-conditions").appendChild(__li);

	new Effect.Appear(
		__li,
		{
			duration: 0.5,
			afterFinish: function(e)
			{
				setLayoutSearch();
			}
		}
	);

	return false;
}

function updatePagerInSearchResult (offsets, string_search)
{
	Element.show("search-pager");
	Element.update("search-pager-num", offsets["num"]);

	// store offsets
	$("search-offset-prev").value = offsets.prev;
	$("search-offset-next").value = offsets.next;
	$("search-offset-current").value = offsets["current"];

	var __id_prev = "search-pager-prev";
	var __id_next = "search-pager-next";
	var __id_offset_prev = "search-offset-prev";
	var __id_offset_next = "search-offset-next";

	if (offsets.prev != -1)
	{
		$(__id_prev).className = "";
		$(__id_prev).onclick = function(e)
		{
			new Ajax.Request(
				"/api/channel/searchChannelEntry/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: string_search + "&offset=" + $(__id_offset_prev).value,
					onLoading: function(e)
					{
						new Effect.Progress("search-content");
					},
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update(
								"search-content", request.responseText);

							__PAGE__.reset("search");
						}
					}
				}
			);
		}
	} else {
		$(__id_prev).className = "disabled";
		$(__id_prev).onclick = dummy;
	}

	if (offsets.next)
	{
		$(__id_next).className = "";
		$(__id_next).onclick = function(e)
		{
			new Ajax.Request(
				"/api/channel/searchChannelEntry/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: string_search + "&offset=" + $(__id_offset_next).value,
					onLoading: function(e)
					{
						new Effect.Progress("search-content");
					},
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update(
								"search-content", request.responseText);
							__PAGE__.reset("search");
						}
					}
				}
			);
		}
	} else {
		$(__id_next).className = "disabled";
		$(__id_next).onclick = dummy;
	}
}

/* search end */

/* memo begin */

function viewPreviousMemoInEditor_orig (uid, id_channel, id_entry, id_memo)
{

	new Ajax.Request(
		"/api/memo/getMemo/",
		{
			asycronous: true,
			evalScripts: true,
			parameters: "id_memo=" + id_memo,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					this.parentNode.runHide();
					var __o = request.responseText.parseJSON();
					if (__o.content)
					{
						var __current =
							this.parentNode.parentNode.getAttribute("current_visible");
						if (__current && __current != this.parentNode.id)
						{
							$(__current).runHide();
						}


					}
				}
			}
		}
	);


}

function viewPreviousMemoInEditor_orig (uid, id_channel, id_entry, id_memo)
{
	var __id_preview =
		"memo-editor-preview-" + uid + "-" + id_channel + "-" + id_entry;
	var __id_memo =
		"memo-editor-memo-" + uid + "-" + id_channel + "-" + id_entry;
	var __id_textarea =
		"memo-editor-textarea-" + uid + "-" + id_channel + "-" + id_entry;

	var __id_tab = "memo-editor-tab-" + uid + "-" + id_channel + "-" + id_entry;
	var __id_memo_tab =
		"memo-editor-tab-memo-" + uid + "-" + id_channel + "-" + id_entry;

	new Ajax.Request(
		"/api/memo/getMemo/",
		{
			asycronous: true,
			evalScripts: true,
			parameters: "id_memo=" + id_memo,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					var __o = request.responseText.parseJSON();
					if (__o.content)
					{
						Element.update(__id_memo, __o.content);

						if ($(__id_tab).className != "active")
						{
							var __children = findChildren(__id_tab, "LI");
							$A(__children).each(
								function(c)
								{
									if (c.id == __id_memo_tab)
									{
										c.className = "active";
									} else {
										c.className = "";
									}
								}
							);

							if ($(__id_memo).style.display == "none")
							{
								Element.hide(__id_textarea);
								Element.hide(__id_preview);
								Element.show(__id_memo);
							}
						}
					}
				}
			}
		}
	);

}
/* memo end */

/* audio play begin */
function audioPlayer (title, file_audio)
{
	window.open(
		"/etc/audioplayer/?file=" + encodeURIComponent(file_audio) +
			"&title=" + encodeURIComponent(title),
		title + " - aguzzim",
		"width=300px, height=10px"
	);

	return;
}

/* audio play end */

