function get_unique_id ()
{
	return Math.floor(Math.random()*1000000000000000000000);
}

/* ************************************************** */
/* REQUEST FUNCTION */
function send_request (url, parameters, func_oncomplete, func_onloading)
{
	return new Ajax.Request(
		url,
		{
			asyncronous: true,
			evalScripts: true,
			onLoading: func_onloading,
			onComplete: func_oncomplete
		}
	);
}

/* ************************************************** */
/* ETC FUNCTION */
function dummy ()
{
	return false;
}

function findChildrenByClassName (id_element, className)
{
   var __children= new Array();
	if (id_element.childNodes)
	{
		var element = id_element;
	} else {
		var element = $(id_element);
	}

   $A(element.childNodes).each(
      function(e)
      {
         if (e.className && e.className.toString() == className)
         {
            __children.push(e);
         }
      }
   );

   return __children;
}

function findChildren (id_element, tagName)
{
   var __children= new Array();
   $A($(id_element).childNodes).each(
      function(e)
      {
         if (e.tagName && e.tagName.toUpperCase()== tagName.toUpperCase())
         {
            __children.push(e);
         }
      }
   );

   return __children;
}

function trimString(sInString) {
  sInString = sInString.replace( /^\s+/g, "" ); // strip leading
  return sInString.replace( /\s+$/g, "" ); // strip trailing
}

function isExists (id_element)
{
	if (! document.getElementById(id_element))
	{
		return false;
	} else {
		return true;
	}
}

function isMSIE ()
{
	if(/MSIE/.test(navigator.userAgent))
	{
		return true;
	}

	return false;
}

function getOffsetRight (id_element)
{
	//var __width = document.body.offsetWidth;
	var __width = window.innerWidth;
	var __width_box = $(id_element).offsetWidth;
	var __left = $(id_element).offsetLeft;

	if (__width < (__left + __width_box))
	{
		return __width;
	}

	return __width - (__left + __width_box);
}

function makeQuery (a, keyname)
{
	var __hrefs = new Array();
	$A(a).each(
		function(i)
		{
			if (i) __hrefs.push(keyname + "=" + encodeURIComponent(i));
		}
	);
	return __hrefs.join("&");
}

function resizeImage (img, w_max, h_max)
{
	// image ratio is 16:9
	var __height = img.offsetHeight;
	var __width = img.offsetWidth;
	if (img.offsetWidth > w_max)
	{
		var __ratio = w_max / __width;
		__width = w_max;
		__height = __height * __ratio;

		img.style.width = w_max + "px";
		img.style.height = __height + "px";
	}
	if (__height > h_max)
	{
		var __ratio = h_max / __height;
		__height = h_max;

		img.style.height = h_max + "px";
		img.style.width = __width * __ratio + "px";
	}
}

function getKeyChar (e)
{
	return String.fromCharCode(e.charCode)
}

function getKeyCode (e)
{
	var __key = null;
	if (e.target) // NS
	{
		__key = e.keyCode;
	} else if (e.srcElement) { // IE
		__key = e.charCode;
	}

	return __key;
}

function onInputTextKeyPress (obj_input, e)
{
	/*
	return:
		-1		: calll onblur()
		false	: cancel
		true	: pass
	*/
	var __key = getKeyCode(e)
	if (__key == 13) // enter
	{
		obj_input.blur();
		return -1;
	} else if (__key == 27) {
		return false;
	}

	return true;
}

Object.prototype.runHide = function() {
	var __script = this.getAttribute("onhide");
	if (__script)
	{
		eval(__script);
	}
}

Object.prototype.innerHTMLUnEscape = function(html) {
	this.innerHTML = html.unescapeHTML();

	return true;
}


