
Running = Class.create();
Object.extend(Running.prototype, {
	initialize: function(element)
	{
		if (typeof element == "object")
		{
			this.element = element;
		} else {
			this.element = $(element);
		}
		this.setup();
	},
	setup: function()
	{
		this.div = document.createElement("DIV");

		var __style = {
			position: "fixed",
			top: this.element.offsetTop + "px",
			left: this.element.offsetLeft + "px",
			width: this.element.offsetWidth + "px",
			height: this.element.offsetHeight + "px",
			backgroundColor: "white",
			zIndex: 100000,
			display: "none"
		}
		var __style_image = {
			position: "fixed",
			top: this.element.offsetTop +
				(this.element.offsetHeight / 2)+ "px",
			left: this.element.offsetLeft + (this.element.offsetWidth / 2) + "px"
		}

		var __image = document.createElement("IMG");
		__image.src = "/__media__/image/running1.gif";

		this.div.appendChild(__image);
		__image.setStyle(__style_image);

		this.div.setStyle(__style);
		this.div.setOpacity(0.5);
		this.element.parentNode.appendChild(this.div);
	},
	begin: function()
	{
		this.div.style.display = "";
	},
	end: function()
	{
		var __self = this;
		new Effect.Fade(
			this.div,
			{
				duration: 1,
				afterFinish: function(e)
				{
					__self.element.parentNode.removeChild(__self.div);
				}
			}
		);
	}
});


