# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import sys, sre

class PYTHON :

	BUFFER = tuple()
	CLASS_MEMBERS = dict()
	LIST_CLASS_MEMBERS = list()
	FUNCTIONS = list()
	THIS_IS_CLASS = False
	CLASS_NAME = str()
	NUMBER_OF_INDENT_OF_THIS_CLASS = 0

	def __init__ (self) :
		pass

	def readFile (self, filename) :
		try :
			fd = file(filename)
			self.BUFFER = fd.readlines()
			fd.close()
		except IOError :
			self.BUFFER = list()

	THIS_LINE = 0
	def format (self) :
		self.THIS_LINE = 1
		self.CLASS_MEMBERS = dict()
		self.FUNCTIONS = list()
		self.CLASS_NAME = str()

		for i in self.BUFFER :
			if self.isClass(i) :
				self.THIS_IS_CLASS = True
				__class_name = self.parseClass(i)
				self.CLASS_MEMBERS[__class_name] = list()

				self.CLASS_NAME = __class_name
				self.LIST_CLASS_MEMBERS.append(__class_name)

			elif self.isDef(i) :
				(indent, function_name, ) = self.parseDef(i)

				if not self.THIS_IS_CLASS or indent < 1:
					self.FUNCTIONS.append( \
						(function_name, self.THIS_LINE, ) \
					)
				else :
					self.CLASS_MEMBERS[self.CLASS_NAME].append( \
						(function_name, self.THIS_LINE, ) \
					)
			else :
				pass

			self.THIS_LINE += 1

	def isClass (self, line) :
		__a = sre.compile("class[ \t][ \t]*.* :").findall(line)
		if len(__a) < 1 : return False
		return True

	def isDef (self, line) :
		__a = sre.compile("def[ \t][ \t]*.* :").findall(line)
		if len(__a) < 1 : return False
		return True

	def isMember (self, line) :
		pass

	def parseClass (self, line) :
		__a = sre.compile( \
			"class[ \t][ \t]*").split(line)[1].split( \
				"(")[0].replace(":", "").strip()

		return __a

	def parseDef (self, line) :
		__a = sre.compile("def[ \t][ \t]*.*\(.*\)[ \t][ \t]*:").split(line)[0]
		__name = sre.compile("def[ \t][ \t]*").split(line)[1].split("(")[0].strip()

		return (len(__a), __name, )

if __name__ == "__main__" :
	__b = file(sys.argv[1], "r").readlines()

	p = Parse(__b)
	p.run()

	print "==========================================="
	print p.CLASS_MEMBERS
	print "==========================================="
	print p.FUNCTIONS


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Parser.py"


