# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def format_log_string (label_widget, message, type="error") :
	label_widget.set_property("use-markup", True)
	if type == "info" :
		__message = "<span size=\"small\">%s</span>" % message
	else :
		__message = "<span size=\"small\" foreground=\"#DA3C14\">%s</span>" % message

	label_widget.set_markup(__message)

def abbrevTime (t) :
	if t > 3600: # 1 hour
		hours = int(t / 3600)
		t -= (3600 * hours)
		mins = int(t / 60)
		t -= (60 * mins)
		return "%i:%02i:%02i" % (hours, mins, t)
	else :
		mins = int(t/60)
		t -= (60 * mins)
		return "%02i:%02i" % (mins, t)



"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "func.py"


