# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

##################################################
# TERMINAL COLOR PALETTE.
TERMINAL_PALETTE = dict()
TERMINAL_PALETTE["xterm"] = (
	"#000000000000", \
	"#CDCB00000000", \
	"#0000CDCB0000", \
	"#CDCBCDCB0000", \
	"#1E1A908FFFFF", \
	"#CDCB0000CDCB", \
	"#0000CDCBCDCB", \
	"#E5E2E5E2E5E2", \
	"#4CCC4CCC4CCC", \
	"#FFFF00000000", \
	"#0000FFFF0000", \
	"#FFFFFFFF0000", \
	"#46458281B4AE", \
	"#FFFF0000FFFF", \
	"#0000FFFFFFFF", \
	"#FFFFFFFFFFFF", \
)

TERMINAL_PALETTE["linux"] = (
	"#000000000000", \
	"#AAAA00000000", \
	"#0000AAAA0000", \
	"#AAAA55550000", \
	"#00000000AAAA", \
	"#AAAA0000AAAA", \
	"#0000AAAAAAAA", \
	"#AAAAAAAAAAAA", \
	"#555555555555", \
	"#FFFF55555555", \
	"#5555FFFF5555", \
	"#FFFFFFFF5555", \
	"#55555555FFFF", \
	"#FFFF5555FFFF", \
	"#5555FFFFFFFF", \
	"#FFFFFFFFFFFF", \
)

TERMINAL_PALETTE["rxvt"] = (
	"#000000000000", \
	"#CDCD00000000", \
	"#0000CDCD0000", \
	"#CDCDCDCD0000", \
	"#00000000CDCD", \
	"#CDCD0000CDCD", \
	"#0000CDCDCDCD", \
	"#FAFAEBEBD7D7", \
	"#404040404040", \
	"#FFFF00000000", \
	"#0000FFFF0000", \
	"#FFFFFFFF0000", \
	"#00000000FFFF", \
	"#FFFF0000FFFF", \
	"#0000FFFFFFFF", \
	"#FFFFFFFFFFFF", \
)

VTE_FGCOLOR_BUILTIN_SCHEMES_LIST = [ \
	("black_and_light_yellow", "Black and Light Yellow", ("#000000", "#FFFFDD",), ), \
	("black_on_white", "Black on White", ("#000000", "#FFFFFF",), ), \
	("gray_on_black", "Gray on Black", ("#AAAAAA", "#000000",), ), \
	("green_on_black", "Green on Black", ("#00FF00", "#000000",), ), \
	("white_on_black", "White on Black", ("#FFFFFF", "#000000",), ), \
	("custom", "Custom", ("", "",), ), \
]

VTE_PALETTE_BUILTIN_SCHEMES_LIST = [ \
	("linux", "Linux Console", ), \
	("xterm", "xterm", ), \
	("rxvt", "RXVT", ), \
]

COLOR_BUTTON_PALETTE_SCHEMES_LIST = \
	["23", "24", "25", "26", "27", "28", "29", "30", \
		"31", "32", "33", "34", "35", "36", "37", "38", ]

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "main.py"


