# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal
from vee import i18n, __OS__
from vee.child import __VTE__

_ = i18n.gettext()

class egg (__VTE__.egg) :
	PATH = "~"

	def __init__ (self, state, **kwargs) :
		__VTE__.egg.__init__(self, state, **kwargs)

		self.getLabelName = self.getTitle

	def parse_command (self) :
		(__command, __argument, __environment, __directory, ) = \
			__VTE__.egg.parse_command(self)

		if not self.PROPERTIES.has_key("path") :
			self.PATH = os.getcwd()
		else :
			self.PATH = self.PROPERTIES["path"]

		return (__command, __argument, __environment, self.PATH, )

	def attached (self, obj_tab) :
		__VTE__.egg.attached(self, obj_tab)

	def getTitle (self) :
		__t = __VTE__.egg.getTitle(self)

		if not __t : return self.PATH

		__t0 = "".join(__t.split(":")[1:]).strip()

		if len(__t0) < 1 :
			__title = __t
		else :
			__title = __t0

		return __title

	def on_changed_title (self) :
		__title = self.getTitle()
		self.setProperty("path", __title)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "egg.py"


