# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import model
from model import configuration_user as model_configuration_user

def casting (value) :
	if value.typeValue == "int" :
		return int(value.value)
	elif value.typeValue == "str" :
		return str(value.value)
	else :
		return value.value

def get_value (name) :
	__value = list(model.Configuration.select( \
		model.Configuration.q.name == name))

	if not __value :
		return None
	else :
		return __value[0]
	
def get_config (name) :
	__value = get_value(name)
	if not __value :
		return None
	else :
		return casting(__value)
	

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Config.py"


