# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from model.memo_user import get_model as get_model_memo_user
from model.memo_property_user \
	import get_model as get_model_memo_property_user
from model.memo_media_user \
	import get_model as get_model_memo_media_user
from model.memo_history_user \
	import get_model as get_model_memo_history_user

class Memo :

	ID_USER = None

	MEMO = None
	MEMO_PROPERTY = None
	MEMO_MEDIA = None
	MEMO_HISTORY = None

	def __init__ (self, id_user) :
		self.ID_USER = id_user
		self.MEMO = get_model_memo_user(id_user)
		self.MEMO_PROPERTY = get_model_memo_property_user(id_user)
		self.MEMO_MEDIA = get_model_memo_media_user(id_user)
		self.MEMO_HISTORY = get_model_memo_history_user(id_user)

	def get (self, id_memo) :
		return self.MEMO.get(id_memo)

	def set (self, **kwargs) :
		if not kwargs.has_key("id_memo") :
			raise ValueError, "keyword argument, id_memo must be given."

		if not kwargs.has_key("data") :
			raise ValueError, "keyword argument, data must be given."

		__id_memo = kwargs["id_memo"]

		# check whether id_memo exists or not
		__memo = self.MEMO.get(id_memo)
		if not __memo : # create new one
			raise ValueError, "this memo, %s does not exists." % __id_memo

		__data = kwargs.get("data", dict())

		__value_memo = __data.get("memo", dict())
		__value_media = __data.get("media", dict())

		# if memo' title or media is changed, write history

		print __memo
		print __media
		print __history

		__changed_title = False
		__changed_content = False
		__changed_media = False

		# write memo
		for i, j in __value_memo.items() :
			if i == "content" and __memo.content != j :
				__changed_content = True

			if i == "title" and __memo.title != j :
				__changed_title = True

			setattr(__memo, i, j) :

		# write media



"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "1.py"


