# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from django.utils.httpwrappers import HttpResponse
from model import configuration_user as __config_user
from django.models.auth import users

import libwww.func
import http

def validateUrl (request) :
	"""
	@retval,
		valid : validated url,
		not valid : exit status code, 404
	"""
	__argument = request.POST.copy()
	if not __argument.has_key("url") : return http.exitWithStatus(404)

	__r = http.validate_url(__argument["url"])
	if not __r :
		return http.exitWithStatus(404)
	else :
		return HttpResponse(__r)

@libwww.func.anonymouse_to_404
def setConfig (request) :
	__user = request.session.get("user", False)
	__argument = request.POST.copy()

	for k, v in __argument.items() :
		if k == "_" : continue

		if not __config_user.set_value(__user.id, k, v) :
			return http.exitWithStatus(404)

	return http.exitWithStatus(200)


__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "views.py"


