function getHeightMain ()
{
	return $("footer").offsetTop -
		$("block_content-main").offsetTop - 30;
}

function setScrollTop ()
{
	$("block_content-main").scrollTop = 0;
}

function setLayoutEditor ()
{
	var __height =
		($("footer").offsetTop - $("block_content-editor").offsetTop - 30);
	$("block_content-editor").style.height = __height + "px";

	return;
}

function setLayoutTagListLabel ()
{
	var __id_block_content = "block_content-main";
	var __id_block_labels =
		"block_content-main-view_channels-content-tag_list-labels";

	var __height = $(__id_block_content).offsetHeight;
	var __top = $(__id_block_content).offsetTop;
	var __top_labels = __top + $(__id_block_labels).offsetTop;

	var __height_for_labels = (__top + __height) - __top_labels;

	if ($(__id_block_labels).offsetHeight > (__height - 100))
	{
		$(__id_block_labels).style.height = __height_for_labels + "px";
	}
}

function setLayoutLogin ()
{
	$("footer").style.left = $("content").offsetLeft + "px";

	$("content").style.height = $("footer").offsetTop - $("content").offsetTop + "px";
	var __height = ($("footer").offsetTop - $("block_content-main").offsetTop - 30);

	$("block_content-main").style.height = __height + "px";
	return;
}

function setLayoutViewChannels ()
{
	var __id_tag_list = "block_content-main-view_channels-content-tag_list";
	var __id_tag_list_content =
		"block_content-main-view_channels-content-tag_list-content";
	var __id_channel_list = "block_content-main-view_channels-content-channel_list";

	$(__id_tag_list).style.width = $(__id_tag_list).offsetWidth + "px";
	$(__id_tag_list_content).style.position = "fixed";
}

function getWidthMain ()
{
	return $("block_content-main").offsetWidth;
}

function setLayout ()
{
	$("footer").style.left = $("content").offsetLeft + "px";

	$("content").style.height = $("footer").offsetTop - $("content").offsetTop + "px";

	var __height =
		$("footer").offsetTop - $("block_content-main").offsetTop;

	$("block_content-main").style.height = __height + "px";

	return;
}

function updateEntriesViewChannel (id_channel)
{
	new Ajax.Request(
		"/api/getEntriesViewChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel + "&offset=0",
			onLoading: function(e)
			{
				setStartRunning();
			},
			onComplete: function(request)
			{
				setStopRunning();
				if (request.status == 200)
				{
					Element.update("block_content-main-view_channel-content",
						request.responseText);
				}
			}
		}
	);
	return;
}

function showFadeLayer ()
{
	Element.show("block_content-layer");
	Element.setOpacity("block_content-layer", 0.5);
}

function hideFadeLayer ()
{
	Element.hide("block_content-layer");
}

function setStartRunning ()
{
	Element.show("block_content-layer");
	Element.setOpacity("block_content-layer", 0.5);
	var __progress = document.createElement("IMG");
	__progress.id = "progress_bar";
	__progress.src = "/__media__/image/running.gif";
	__progress.style.zIndex = "1500";

	$("altbody").appendChild(__progress);
	__progress.style.position = "absolute";
	__progress.style.top =
		($("block_content-main").offsetTop +
			($("block_content-main").offsetHeight /2)) + "px";
	__progress.style.left =
		($("block_content-main").offsetLeft +
			($("block_content-main").offsetWidth /2)) + "px";
}

function setStopRunning ()
{
	$("altbody").removeChild($("progress_bar"));
	Element.update("block_content-layer", "");
	Element.hide("block_content-layer");
}

function updateEntriesFrontpage ()
{
	new Ajax.Request(
		"/api/getEntriesFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "offset=0",
			onLoading: function(e)
			{
				setStartRunning();
			},
			onComplete: function(request)
			{
				setStopRunning();
				if (request.status == 200)
				{
					Element.update("block_content-main-frontpage-content",
						request.responseText);
					setScrollTop();
				}
			}
		}
	);
	return;
}

function changeTermOfEntriesInViewChannel (id_channel, t, t_label)
{
	new Ajax.Request(
		"/api/changeTermOfEntriesInViewChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "term=" + t + "&id_channel=" + id_channel,
			onComplete: function(request)
			{
				Element.update(
					"block_content-header-view_channel-term-text",
					t_label
				);
				new Ajax.Request(
					"/api/getEntriesViewChannel/",
					{
						asyncronous: true,
						evalScripts: true,
						parameters: "offset=0&id_channel=" + id_channel,
						onComplete: function(request)
						{
							if (request.status == 200)
							{
	Element.update("block_content-main-view_channel-content", request.responseText);
							}
						}
					}
				);
			}
		}
	);

	new Effect.Fade("block_content-header-view_channel-show_entries_since");
	return;
}

function changeTermOfEntriesInFrontpage (t, t_label)
{
	new Ajax.Request(
		"/api/changeTermOfEntriesInFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "term=" + t,
			onComplete: function(request)
			{
				Element.update(
					"block_content-header-frontpage-term-text",
					t_label
				);
				new Ajax.Request(
					"/api/getEntriesFrontpage/",
					{
						asyncronous: true,
						evalScripts: true,
						parameters: "offset=0",
						onComplete: function(request)
						{
							if (request.status == 200)
							{
	Element.update("block_content-main-frontpage-content", request.responseText);
	new Effect.Fade("block_content-header-frontpage-show_entries_since");
							}
						}
					}
				);
			}
		}
	);

	return;
}

function updatePagerInViewChannel (id_channel, offsets)
{
	// store offsets
	$("block_content-header-view_channel-offset-prev").value = offsets["prev"];
	$("block_content-header-view_channel-offset-next").value = offsets["next"];
	$("block_content-header-view_channel-offset-current").value = offsets["current"];

	var __id_last_prev = "block_content-header-view_channel-pager-last_prev";
	var __id_prev = "block_content-header-view_channel-pager-prev";
	var __id_next = "block_content-header-view_channel-pager-next";
	var __id_last_next = "block_content-header-view_channel-pager-last_next";

	if (offsets["prev"] == -1)
	{
		$(__id_last_prev).className = "inactive";
		$(__id_last_prev).onclick = dummy;
	} else {
		$(__id_last_prev).className = "active";
		$(__id_last_prev).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesViewChannel/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=0&id_channel=" + id_channel,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-view_channel-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}
	}

	if (offsets["next"] == 0)
	{
		$(__id_last_next).className = "inactive";
		$(__id_last_next).onclick = dummy;
	} else {
		$(__id_last_next).className = "active";
		$(__id_last_next).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesViewChannel/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=-1&id_channel=" + id_channel,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-view_channel-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}

	}

	if (offsets["prev"] != -1)
	{
		$(__id_prev).className = "active";
		$(__id_prev).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesViewChannel/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=" + offsets["prev"] + "&id_channel=" + id_channel,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-view_channel-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}
	} else {
		$(__id_prev).className = "inactive";
		$(__id_prev).onclick = dummy;
	}

	if (offsets["next"])
	{
		$(__id_next).className = "active";
		$(__id_next).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesViewChannel/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=" + offsets["next"] + "&id_channel=" + id_channel,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-view_channel-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}

	} else {
		$(__id_next).className = "inactive";
		$(__id_next).onclick = dummy;
	}

}


function updatePagerInSearchResult (offsets, string_search)
{
	// store offsets
	$("search-offset-prev").value = offsets["prev"];
	$("search-offset-next").value = offsets["next"];
	$("search-offset-current").value = offsets["current"];

	var __id_prev = "block_content-header-search-result-pager-prev";
	var __id_next = "block_content-header-search-result-pager-next";
	var __id_offset_prev = "block_content-header-search-result-offset-prev";
	var __id_offset_next = "block_content-header-search-result-offset-next";

	if (offsets["prev"] != -1)
	{
		$(__id_prev).className = "active";
		$(__id_prev).onclick = function(e)
		{
			new Ajax.Request(
				"/channel/search/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "input_search=" + string_search +
						"&offset=" + $(__id_offset_prev).value,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update(
								"block_content-search-result", request.responseText);
						}
					}
				}
			);
		}
	} else {
		$(__id_prev).className = "inactive";
		$(__id_prev).onclick = dummy;
	}

	if (offsets["next"])
	{
		$(__id_next).className = "active";
		$(__id_next).onclick = function(e)
		{
			new Ajax.Request(
				"/api/search/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "input_search=" + string_search +
						"&offset=" + $(__id_offset_next).value,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update(
								"block_content-search-result", request.responseText);
						}
					}
				}
			);
		}
	} else {
		$(__id_next).className = "inactive";
		$(__id_next).onclick = dummy;
	}
}

function updatePagerInFrontpage (offsets)
{
	// store offsets
	$("block_content-header-frontpage-offset-prev").value = offsets["prev"];
	$("block_content-header-frontpage-offset-next").value = offsets["next"];
	$("block_content-header-frontpage-offset-current").value = offsets["current"];

	var __id_last_prev = "block_content-header-frontpage-pager-last_prev";
	var __id_prev = "block_content-header-frontpage-pager-prev";
	var __id_next = "block_content-header-frontpage-pager-next";
	var __id_last_next = "block_content-header-frontpage-pager-last_next";

	if (offsets["prev"] == -1)
	{
		$(__id_last_prev).className = "inactive";
		$(__id_last_prev).onclick = dummy;
	} else {
		$(__id_last_prev).className = "active";
		$(__id_last_prev).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=0",
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-frontpage-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}
	}

	if (offsets["next"] == 0)
	{
		$(__id_last_next).className = "inactive";
		$(__id_last_next).onclick = dummy;
	} else {
		$(__id_last_next).className = "active";
		$(__id_last_next).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=-1",
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-frontpage-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}

	}

	if (offsets["prev"] != -1)
	{
		$(__id_prev).className = "active";
		$(__id_prev).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=" + offsets["prev"],
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-frontpage-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}
	} else {
		$(__id_prev).className = "inactive";
		$(__id_prev).onclick = dummy;
	}

	if (offsets["next"])
	{
		$(__id_next).className = "active";
		$(__id_next).onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=" + offsets["next"],
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-frontpage-content",
								request.responseText);
							setScrollTop();
						}
					}
				}
			);
		}

	} else {
		$(__id_next).className = "inactive";
		$(__id_next).onclick = dummy;
	}

}

function setAsRead (id_channel, id_entry)
{
	new Ajax.Request(
		"/api/setAsReadChannelEntry/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel + "&id_entry=" + id_entry,
			onComplete: function(request)
			{
			}
		}
	);
}

function markAsSkip (id_element)
{
	$(id_element).className = "entry_skip";
}

function markAsRead (id_element)
{
	$(id_element).className = "entry_read";
}

function setAsStar (id_channel, id_entry)
{
	new Ajax.Request(
		"/api/setAsStarChannelEntry/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel + "&id_entry=" + id_entry,
			onComplete: function(request)
			{
			}
		}
	);
}

function markAsStar (id_channel, id_entry)
{
	/*
	var __id = "block_channel_entry-" + id_channel + "-" + id_entry + "-mark";
	var __img = document.createElement("IMG");
	__img.src = "/__media__/image/sun_25.png";

	Element.update(__id, "");
	$(__id).appendChild(__img);
	*/
	var __id = "block_channel_entry-" + id_channel + "-" + id_entry;
	$(__id).className = "entry_star";
}

function markAsUnStar (id_channel, id_entry)
{
	var __id = "block_channel_entry-" + id_channel + "-" + id_entry + "-mark";
	Element.update(__id, "");
}

function toggleStar (id_channel, id_entry)
{
	var __id = "block_channel_entry-" + id_channel + "-" + id_entry + "-mark";
	if (! trimString($(__id).innerHTML)) // set star
	{
		//markAsStar(id_channel, id_entry)
		new Ajax.Request(
			"/api/setAsStarChannelEntry/",
			{
				asyncronous: true,
				evalScripts: true,
				parameters: "id_channel=" + id_channel + "&id_entry=" + id_entry,
				onComplete: function(request)
				{
				}
			}
		);
	} else { // set un-star
		//markAsUnStar(id_channel, id_entry)
		new Ajax.Request(
			"/api/setAsStarChannelEntry/",
			{
				asyncronous: true,
				evalScripts: true,
				parameters: "value=0&id_channel=" + id_channel + "&id_entry=" + id_entry,
				onComplete: function(request)
				{
				}
			}
		);

	}
}

function viewSummaryViewChannel (id_channel, id_entry)
{
	var __e_original =
		"block_channel-main-entry-summary-original-" + id_channel +
			"-" + id_entry;
	var __e_brief =
		"block_channel-main-entry-summary-brief-" + id_channel +
			"-" + id_entry;

	var __text = "";
	if ($(__e_original).style.display == "none")
	{
		Element.show(__e_original);
		Element.hide(__e_brief);
		__text = "-";
	} else {
		Element.show(__e_brief);
		Element.hide(__e_original);
		__text = "+";
	}
	this.innerHTML = __text;

	/*
	setAsRead(id_channel, id_entry);
	markAsRead("block_channel_entry-" + id_channel + "-" + id_entry);
	*/

	return;
}

function viewSummaryFrontpage (id_channel, id_entry)
{
	var __e_original =
		"block_channel-main-frontpage-entry-summary-original-" + id_channel +
			"-" + id_entry;
	var __e_brief =
		"block_channel-main-frontpage-entry-summary-brief-" + id_channel +
			"-" + id_entry;

	var __text = "";
	if ($(__e_original).style.display == "none")
	{
		Element.show(__e_original);
		Element.hide(__e_brief);
		__text = "-";
	} else {
		Element.show(__e_brief);
		Element.hide(__e_original);
		__text = "+";
	}
	this.innerHTML = __text;

	/*
	setAsRead(id_channel, id_entry);
	markAsRead("block_channel_entry-" + id_channel + "-" + id_entry);
	*/

	return;
}

function setSkipAllEntryInThisChannel (id_channel)
{
	var __reg = new RegExp("^block_channel_entry-" + id_channel + "-", "g");
	var __children = findChildren("block_content-main-frontpage-content", "DIV");
	$A(__children).each(
		function(i)
		{
			if (i.id.search(__reg) == -1)
			{
				return;
			} else {
				if (i.className == "entry_read") return;
				if (i.className == "entry_skip") return;
				i.style.backgroundColor = "#e9e9e9";
			}
		}
	);
	new Ajax.Request(
		"/api/setSkipChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel,
			onComplete: function(request)
			{
				//alert(request.responseText);
			}
		}
	);
	return false;
}

function setSkipAllEntryInFrontpage (callback)
{
	setAllPostInthisPageAsSkip(callback);
	/*
	new Effect.BlindUp(
		"block_content-header-frontpage-actions-ul",
		{
			duration: 0.5
		}
	);
	*/

	// update offsets
	var __prev = parseInt($("block_content-header-frontpage-offset-prev").value);
	var __next = parseInt($("block_content-header-frontpage-offset-next").value);
	var __current =
		parseInt($("block_content-header-frontpage-offset-current").value);

	__next_new = __next - 1;
	__prev_new = __prev - 1;
	if (__prev > -1 && __prev_new < 0)
	{
		$("block_content-header-frontpage-pager-prev").onclick = null;
		$("block_content-header-frontpage-pager-prev").src =
			"/__media__/image/arrow_prev_off.png";
	} else {
		$("block_content-header-frontpage-pager-prev").onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=" + __prev_new,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-frontpage-content",
								request.responseText);
							$("block_content-main").scrollTop = 0;
						}
					}
				}
			);
		}
	}

	if (__next_new > 0)
	{
		$("block_content-header-frontpage-pager-next").onclick = function(e)
		{
			new Ajax.Request(
				"/api/getEntriesFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					parameters: "offset=" + __next_new,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							Element.update("block_content-main-frontpage-content",
								request.responseText);
							$("block_content-main").scrollTop = 0;
						}
					}
				}
			);
		}
	}

	return;
}

function removeThisChannelEntriesFromFrontpage (id_channel, value, callback)
{
	new Ajax.Request(
		"/api/removeChannelFromFrontpage/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + id_channel + "&value=" + value,
			onComplete: function(request)
			{
				if (callback) callback(id_channel);
			}
		}
	);

}

function removeThisChannelEntriesFromFrontpageInFrontpage (id_channel)
{
	var callback = function(id_channel)
	{
		var __reg = new RegExp("^block_channel_entry-" + id_channel + "-", "g");
		var __children = findChildren("block_content-main-frontpage-content", "DIV");
		if (__children.length > 0)
		{
			$A(__children).each(
				function(i)
				{
					if (i.id.search(__reg) == -1)
					{
						return;
					} else {
						i.style.backgroundColor = "#b7c6b6";
					}
				}
			);
		}

	}

	removeThisChannelEntriesFromFrontpage(id_channel, "false", callback);
}

function setAllPostInthisPageAsSkip (callback)
{
	var __children = findChildren("block_content-main-frontpage-content", "DIV");
	var __args = $(__children).map(function(ele) {
		if (! ele.id) return;
		if (ele.className == "entry_read") return;
		if (ele.className == "entry_skip") return;

		if (! callback)
		{
			markAsSkip(ele.id);
		}

		var __id = ele.id.replace(/^block_channel_entry-/g, "");
		return "uid=" + encodeURIComponent(__id);
	}).join("&");

	new Ajax.Request(
		"/api/setAsSkipMany/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __args,
			onComplete: function(request)
			{
				if (callback) callback();
			}
		}
	);
	return false;
}

function updateSortableChannelLabelViewChannel (id_element, id_channel)
{
	new Effect.Appear("trash");
	Sortable.create(
		id_element,
		{
			constraint: false,
			dropOnEmpty: true,
			format: /^[^\-]*\-(.*)$/,
			onUpdate:function()
			{
				var __d = Sortable.serialize(
					this.element.id,
					{
						name: "labels"
					}
				);

				/* update sequence */
				new Ajax.Request(
					"/api/setLabelSequence/",
					{
						asyncronous: true,
						evalScripts: true,
						parameters: __d + "&id_channel=" + id_channel,
						onComplete: function(request)
						{
							//alert(__d);
						}
					}
				);
			}
		}
	);
}

function updateSortableChannelLabel (id_element, id_channel)
{
	new Effect.Appear("trash");
	Sortable.create(
		id_element,
		{
			constraint: false,
			dropOnEmpty: true,
			format: /^[^\-]*\-(.*)$/,
			onUpdate:function()
			{
				var __d = Sortable.serialize(
					this.element.id,
					{
						name: "labels"
					}
				);

				/* update sequence */
				new Ajax.Request(
					"/api/setLabelSequence/",
					{
						asyncronous: true,
						evalScripts: true,
						parameters: __d + "&id_channel=" + id_channel,
						onComplete: function(request)
						{
							//alert(__d);
						}
					}
				);
			}
		}
	);
}

function addTrash ()
{
	Droppables.add(
		"trash",
		{
			accept: ["label_one", "channel_title" ],
			onDrop:function(element)
			{
				if (element.className == "channel_title")
				{
					methodForChannelDropInTrash(element);
				} else if (element.className == "label_one") {
					methodForChannelLabelDropInTrash(element);
				}
			}
		}
	);

}

function addDroppableTrash ()
{
	Droppables.add(
		"block_content-main-view_channels-content-trash",
		{
			accept: ["label_one", "channel_title" ],
			onDrop:function(element)
			{
				if (element.className == "channel_title")
				{
					methodForChannelDropInTrash(element);
				} else if (element.className == "label_one") {
					methodForChannelLabelDropInTrash(element);
				}
			}
		}
	);

}

function methodForChannelDropInTrash (element)
{
	var __template_id_channel =
		"block_content-main-view_channels-content-channel_list-channel-title-";
	var __id_block_channel_list =
		"block_content-main-view_channels-content-channel_list";

	var __id_channel = parseInt(element.id.replace(__template_id_channel, ""));

	var __id_block_channel =
		"block_content-main-view_channels-content-channel_list-channel-" +
			__id_channel;

	// remote-call 'remove label'
	new Ajax.Request(
		"/api/removeChannel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + __id_channel,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					// fade out element
					new Effect.Fade(
						element.id,
						{
							duration: 0.2,
							afterFinish: function(e)
							{
						$(__id_block_channel_list).removeChild($(__id_block_channel));
							}
						}
					);
				}
			}
		}
	);

}

function methodForChannelLabelDropInTrash (element)
{
	var __o = element.id.split(".");
	if (__o.length < 2) return;
	var __oo = __o[0].split("-");
	if (__oo.length < 2) return;

	var __id_channel = __oo[1];
	var __id_label = __o[1];

	// remote-call 'remove label'
	new Ajax.Request(
		"/api/removeChannelLabel/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_channel=" + __id_channel + "&id_label=" + __id_label,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					// fade out element
					new Effect.Fade(
						element.id,
						{
							duration: 0.2,
							afterFinish: function(e)
							{
								// remove element
								element.parentNode.removeChild(element.id);
								updateSortableChannelLabel(
									element.parentNode.id, __id_channel
								);
							}
						}
					);
				}
			}
		}
	);

}

function updateChannelList (id_label)
{
	new Ajax.Request(
		"/api/getChannelList/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: "id_label=" + id_label,
			onComplete: function(request)
			{
				setScrollTop();
				Element.update(
					"block_content-main-view_channels-content-channel_list",
					request.responseText
				);

				// update label list.
				updateChannelLabelList(id_label);
			}
		}
	);
}

function onClickChannelLabelChannelList (li_element, id_label)
{
	var __children = findChildren(li_element.parentNode.id, "LI");
	for (var i = 0; i < __children.length; i++)
	{
		var ele = __children[i];
		if (ele.className != "active") continue;
		ele.className = "";
	}

	li_element.className = "active";
	li_element.classNameOrig = "active";

	updateChannelList(id_label)
	return;
}

function getKeyChar (e)
{
	return String.fromCharCode(e.charCode)
}

function onClickAddNewLabelInViewChannel (id_channel)
{

	var __id = "block_content-header-view_channel-labels-sortable";
	var __id_input = id_channel + "-new";
	var __label_li = document.createElement("LI");
	__label_li.className = "input";
	var __label_input = document.createElement("INPUT");
	__label_input.id = __id_input;
	__label_input.className = "label";
	__label_li.appendChild(__label_input);

	$(__id).appendChild(__label_li);
	__label_input.focus();
	__label_input.onkeypress = function(e)
	{
		var __key = null;
		if (e.target) // NS
		{
			__key = e.keyCode;
		} else if (e.srcElement) { // IE
			__key = e.charCode;
		}

		if (__key == 13)
		{
			this.blur();
			return false;
		} else if (__key == 27) {
			new Effect.Fade(
				__label_li,
				{
					duration: 0.5,
					afterFinish: function(e)
					{
						$(__id).removeChild(__label_li);
					}
				}
			);
			return false;
		} else {
			return true;
		}
	}
	__label_input.onblur = function(e)
	{
		var this_element = this;
		var __label_li = this.parentNode;
		var __value = $(__id_input).value;
		if (! trimString(__value))
		{
			new Effect.Fade(
				this_element.parentNode,
				{
					duration: 0.5,
					afterFinish: function(e)
					{
						$(__id).removeChild(__label_li);
					}
				}
			);
			return;
		}

		new Ajax.Request(
			"/api/setLabel/",
			{
				asyncronous: true,
				evalScripts: true,
				parameters: "id_channel=" + id_channel + "&label=" + encodeURIComponent(__value),
				onComplete: function(request)
				{
					if (request.status != 200) return;
					new Effect.Fade(
						__label_li,
						{
							duration: 0.5,
							afterFinish: function(e)
							{
								var __id_label = request.responseText;

								$(__id).removeChild(__label_li);

								// create new one.
								var __label_li0 = document.createElement("LI");
								__label_li0.style.display = "none";
								__label_li0.className = "label_one";
								__label_li0.innerHTML = __value;
								__label_li0.id = "label-" + id_channel + "." + __id_label;
								__label_li0.onclick = function(e)
								{
									if (this.parentNode.className == "block_labels")
									{
										window.location.href =
											"/channel/viewChannels?id_labels=" + __id_label;
									}
									return false;
								}
								$(__id).appendChild(__label_li0);

								new Effect.Appear(
									__label_li0,
									{
										duration: 0.5,
										afterFinish: function(e)
										{

											var __children = findChildren(__id, "LI");
											// add to label list
											updateSortableChannelLabelViewChannel(__id, id_channel);
										}
									}
								);
							}
						}
					);
				}
			}
		);

	}

	return;
}

function onClickAddNewLabelInChannel (id_channel)
{

	var __id = "block_content-main-view_channels-content-channel_list-channel-info-labels-sortable-" + id_channel;
	var __id_input = id_channel + "-new";
	var __label_li = document.createElement("LI");
	__label_li.className = "input";
	var __label_input = document.createElement("INPUT");
	__label_input.id = __id_input;
	__label_input.className = "label";
	__label_li.appendChild(__label_input);

	$(__id).appendChild(__label_li);
	__label_input.focus();
	__label_input.onkeypress = function(e)
	{
		var __key = null;
		if (e.target) // NS
		{
			__key = e.keyCode;
		} else if (e.srcElement) { // IE
			__key = e.charCode;
		}

		if (__key == 13)
		{
			this.blur();
			return false;
		} else if (__key == 27) {
			new Effect.Fade(
				__label_li,
				{
					duration: 0.5,
					afterFinish: function(e)
					{
						$(__id).removeChild(__label_li);
					}
				}
			);
			return false;
		} else {
			return true;
		}
	}
	__label_input.onblur = function(e)
	{
		var this_element = this;
		var __label_li = this.parentNode;
		var __value = $(__id_input).value;
		if (! trimString(__value))
		{
			new Effect.Fade(
				this_element.parentNode,
				{
					duration: 0.5,
					afterFinish: function(e)
					{
						$(__id).removeChild(__label_li);
					}
				}
			);
			return;
		}

		new Ajax.Request(
			"/api/setLabel/",
			{
				asyncronous: true,
				evalScripts: true,
				parameters: "id_channel=" + id_channel + "&label=" + encodeURIComponent(__value),
				onComplete: function(request)
				{
					if (request.status != 200) return;
					new Effect.Fade(
						__label_li,
						{
							duration: 0.5,
							afterFinish: function(e)
							{
								var __id_label = request.responseText;

								$(__id).removeChild(__label_li);

								// create new one.
								var __label_li0 = document.createElement("LI");
								__label_li0.style.display = "none";
								__label_li0.className = "label_one";
								__label_li0.innerHTML = __value;
								__label_li0.id = "label-" + id_channel + "." + __id_label;
								$(__id).appendChild(__label_li0);

								new Effect.Appear(
									__label_li0,
									{
										duration: 0.5,
										afterFinish: function(e)
										{

											var __children = findChildren(__id, "LI");
											// add to label list
											if (__children.length == 1)
											{
												// check whether __id_label exists or not.

	var __id_new = "block_content-main-view_channels-content-tag_list-labels-label_one-" + __id_label;
												if (! isExists(__id_new))
												{
	// create new one
	var __id_labels = "block_content-main-view_channels-content-tag_list-labels"
	var __label_li = document.createElement("LI");
	__label_li.id = __id_new;
	__label_li.innerHTML = __value;
	__label_li.onload = function(e)
	{
		this.classNameOrig = this.className;
		return false;
	}
	__label_li.onmouseover = function(e)
	{
		this.classNameOrig = this.className;
		this.className ="hover";
		return false;
	}
	__label_li.onmouseout = function(e)
	{
		this.className = this.classNameOrig;
		return false;
	}
	__label_li.onclick = function(e)
	{
		onClickChannelLabel(this, __id_label);
		return false;
	}
													$(__id_labels).appendChild(__label_li);
												}
											}

	if (__ID_CURRENT_SORTABLES_IN_VIEW_CHANNELS__ &&
			$(__ID_CURRENT_SORTABLES_IN_VIEW_CHANNELS__).className == "")
	{
		return false;
	}

											updateSortableChannelLabel(__id, id_channel);
										}
									}
								);
							}
						}
					);
				}
			}
		);

	}

	return;
}

function submitAddChannelGetCandidate ()
{
	Element.update("block_content-add_channel-msg", "");
	Element.hide("block_content-add_channel-msg");
	Element.hide("block_content-add_channel-result");
	Element.show("block_content-add_channel-updating");

	var __s = trimString($("block_content-add_channel-input").value);
	if (! __s)
	{
		Element.update("block_content-add_channel-msg", "Enter string.");
		Element.show("block_content-add_channel-msg");
		Element.hide("block_content-add_channel-updating");
		return false;
	}

	/* valid url */
	new Ajax.Request(
		"/api/validateUrl/",
		{
			parameters: "url=" + encodeURIComponent(__s),
			asyncronous: true,
			evalScripts: true,
			onComplete: function(request)
			{
				if (request.status != 200)
				{
					Element.update(
						"block_content-add_channel-msg",
						"The url invalid url, check it."
					);
					Element.show("block_content-add_channel-msg");
					Element.hide("block_content-add_channel-updating");
					$("block_content-add_channel-input").select();
				} else {
					new Ajax.Request(
						"/api/getRSSUrlCandidate/",
						{
							parameters: "href=" + encodeURIComponent(request.responseText),
							asyncronous: true,
							evalScripts: true,
							onComplete: function(request)
							{
								if (request.status == 200)
								{
									Element.show("block_content-add_channel-result");
									Element.update(
										"block_content-add_channel-result-content",
											request.responseText);
									Element.hide("block_content-add_channel-updating");
								} else if (request.status == 600) {
									Element.hide("block_content-add_channel-result");
									Element.hide("block_content-add_channel-updating");
									Element.update(
										"block_content-add_channel-msg",
										"Already added.");
									Element.show("block_content-add_channel-msg");
								} else {
									Element.hide("block_content-add_channel-updating");
								}
							}
						}
					);
					Element.update("block_content-add_channel-msg", "");
					Element.hide("block_content-add_channel-msg");
				}
			}
		}
	);

	return;
}

function submitAddChannelAdd (element_form)
{
	var __input_list_selected = element_form.block_content_add_channel_selected;
	var __a = new Array();
	if (__input_list_selected.length)
	{
		for (var i = 0; __input_list_selected.length > i; i++)
		{
			var __value = __input_list_selected[i].value;
			if (__value) __a.push(__value);
		}
	} else {
		__a.push(__input_list_selected.value);
	}

	if (__a.length < 1)
	{
		Element.update("block_content-add_channel-msg", "At least select one url.");
		return false;
	} else {
		/* make query string */
		var __hrefs = new Array();
		$A(__a).each(
			function(i)
			{
				__hrefs.push("hrefs=" + encodeURIComponent(i));
			}
		);

		new Ajax.Request(
			"/api/addChannel/",
			{
				asyncronous: true,
				evalScripts: true,
				parameters: __hrefs.join("&"),
				onLoading: function (e)
				{
					Element.show("block_content-add_channel-adding");
				},
				onComplete: function(request)
				{
					Element.hide("block_content-add_channel-adding");
					if (request.status == 200)
					{
						$("block_content-add_channel-input").value = "";
						Element.hide("block_content-add_channel-result");
						Element.update("block_content-add_channel-msg", "Successfully added.");
					} else {
						Element.update("block_content-add_channel-msg",
							"Failed to add this channels. Try again.");
					}
					setTimeout(
						function(e)
						{
							Element.hide("block_content-add_channel-adding");

							//alert(request.responseText.parseJSON());
						},
						10
					);
				}
			}
		);
	}

	return;
}

function audioPlayer (id_parent, file_audio)
{
	window.open(
		"/etc/audioplayer/?file=" + encodeURIComponent(file_audio),
		"AudioPlayer - aguzzim",
		"width=300px, height=10px"
	);

	return;
	/*
	This audio player is from http://www.jeroenwijering.com.
	<embed
		src="mp3player.swf"
		width="150"
		height="20"
		flashvars="file=mp3/homeland.mp3"
		type="application/x-shockwave-flash"
		pluginspage="http://www.macromedia.com/go/getflashplayer"
	/>
	*/
	if (! isExists("block_audio_player-player"))
	{
		var __dummy = document.createElement("SPAN");
		__dummy.id = "block_audio_player-player";
		$(id_parent).appendChild(__dummy);
	}

	new Effect.Fade(
		"block_audio_player-player",
		{
			afterFinish: function(e)
			{
				Element.update(id_parent, "");
				var __embed = document.createElement("EMBED");
				__embed.id = "block_audio_player-player";
				__embed.style._audiodisplay = "none";
				__embed.src =
	"/__media__/swf/audioplayer3.swf?config=/__media__/swf/config.xml&file=" +
		encodeURIComponent(file_audio);
				__embed.flashvars = "";

				__embed.width = "150";
				__embed.height = "19";
				__embed.type = "application/x-shockwave-flash";
				__embed.pluginspage = "http://www.macromedia.com/go/getflashplayer";

				//__ele_object.appendChild(__embed);

				//$("block_audio_player").appendChild(__ele_object);
				$(id_parent).appendChild(__embed);

				new Effect.Appear(__embed.id);
			}
		}
	);
	return;
}

function checkNewEntryFrontpage (timeout)
{
	setTimeout(
		function(e)
		{
			new Ajax.Request(
				"/api/checkNewEntryFrontpage/",
				{
					asyncronous: true,
					evalScripts: true,
					onComplete: function(request)
					{
						if (request.status == 200)
						{
							$("menu-frontpage").className = "newInFrontpage";
							new Effect.Pulsate(
								"menu-frontpage",
								{
									duration: 10.0
								}
							);
						} else {
							$("menu-frontpage").className = "nothingInFrontpage";
						}
						checkNewEntryFrontpage(20000);
					}
				}
			);
		},
		timeout
	);
}

function showAddChannelPage (element_li)
{
	if ($("block_content-add_channel").style.display == "none")
	{
		Element.show("block_content-layer");
		Element.setOpacity("block_content-layer", 0.5);

		Element.show("block_content-add_channel");
		$("block_content-add_channel").style.zIndex = "200";

		// set position.
		$("block_content-add_channel").style.top =
			$("block_content-main").offsetTop + "px";
		$("block_content-add_channel").style.left =
			$("block_content-main").offsetLeft +
				($("block_content-main").offsetWidth / 2) -
				(parseInt($("block_content-add_channel").style.width) / 2) + "px";

		$("block_content-add_channel-input").focus();
		element_li.innerHTML = "Close add channel box";
	} else {
		//Element.show("block_content-main");
		Element.hide("block_content-add_channel");
		Element.hide("block_content-layer");

		element_li.innerHTML = "Add channel";
	}
}

function parseIdOfChannelLabelListUL (ob)
{
	if (ob.tagName.toUpperCase() != "UL") return;
	return parseInt(
		ob.id.replace(
			"block_content-main-view_channels-content-tag_list-labels-",
			""
		)
	);
}

function updateViewChannelByLabel (id_label, name_label)
{
	var __id_labels_in_header = "block_content-header-view_channels-labels";
	var __list_root = [null, "all", "uncategorized"];
	var __id_tag_list =
		"block_content-main-view_channels-content-tag_list-labels";

	var __query_labels = "";
	if ($A(__list_root).indexOf(id_label) != -1)
	{
		Element.update(__id_labels_in_header, "");

		if (id_label == "uncategorized")
		{
			__query_labels = "id_label=uncategorized";
		}
	} else {
		// find out siblings in header.
		var __labels_in_header = findChildren(__id_labels_in_header, "LI");

		// make pool
		var __pool = new Array();
		$A(__labels_in_header).each(
			function(i)
			{
				__id_label = parseInt(i.id.replace("label-", ""));
				if (__id_label)
				{
					__pool.push(__id_label)
				}
			}
		);

		// append labels in header.
		if (__pool.indexOf(id_label) == -1 && name_label)
		{
			var __li_label_in_header = document.createElement("LI");
			__li_label_in_header.innerHTML = name_label;
			__li_label_in_header.id = "label-" + id_label;
			__li_label_in_header.title = "Delete this label";

			var __img_label_in_header = document.createElement("IMG");
			__img_label_in_header.src = "/__media__/image/minus_15.png"
			__li_label_in_header.appendChild(__img_label_in_header);

			__li_label_in_header.onclick = function(e)
			{
				var this_element = this;
				new Effect.Fade(
					this.id,
					{
						afterFinish: function(e)
						{
							// remove itself.updateViewChannelByLabel
							this_element.parentNode.removeChild(this_element);
							updateViewChannelByLabel("", "");
						}
					}
				);
				return false;
			}

			$(__id_labels_in_header).appendChild(__li_label_in_header);
		}

		var __labels_in_header = findChildren(__id_labels_in_header, "LI");
		__query_labels = $A(__labels_in_header).map(
			function(i)
			{
				if (! i.id) return;
				return "id_label=" + encodeURIComponent(i.id.replace("label-", ""));
			}
		).join("&");
	}

	// generate channel labels.
	new Ajax.Request(
		"/api/getChannelLabelList/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __query_labels,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.update(__id_tag_list, request.responseText);

					// generate channel list.
					new Ajax.Request(
						"/api/getChannelList/",
						{
							asyncronous: true,
							evalScripts: true,
							parameters: __query_labels,
							onComplete: function(request)
							{
	setScrollTop();
	Element.update(
		"block_content-main-view_channels-content-channel_list",
		request.responseText
	);
	setLayoutViewChannels();
							}
						}
					);

				}
			}
		}
	);

}

function updateChannelLabelList (id_label_root, callback)
{
	var __id_block_root =
		"block_content-main-view_channels-content-tag_list-labels";
	var __list_root = ["root", "all", "uncategorized"];
	if ($A(__list_root).indexOf(id_label_root) != -1)
	{
		Element.update(__id_block_root, "");
		var __ul_null = document.createElement("UL");
		__ul_null.id =
			"block_content-main-view_channels-content-tag_list-labels-null";
		$(__id_block_root).appendChild(__ul_null);
	}

	var __siblings = findChildren(__id_block_root, "UL");

	var __siblings_new = new Array();
	var __siblings_new_ids = new Array();
	for (var i = 0; i < __siblings.length; i++)
	{
		var __o = __siblings[i];
		if (__o.tagName.toUpperCase() != "UL") continue;

		__siblings_new.push(__o)
		var __id = parseIdOfChannelLabelListUL(__o);
		if (__id && __siblings_new_ids.indexOf(__id) == -1)
		{
			__siblings_new_ids.push(__id)
		}
	}

	var __sibling_last = __siblings_new[__siblings_new.length - 1];
	var __query_ids_label = makeQuery(__siblings_new_ids, "id_labels_previous");

	new Ajax.Request(
		"/api/getChannelLabelList/",
		{
			asyncronous: true,
			evalScripts: true,
			parameters: __query_ids_label + "&id_label_root=" + id_label_root,
			onComplete: function(request)
			{
				if (request.status == 200)
				{
					Element.hide(__sibling_last.id);
					new Insertion.After(__sibling_last.id, request.responseText);
					/*
					new Effect.Fade(
						__sibling_last.id,
						{
							duration: 0.5,
							beforeFinish: function(e)
							{
								new Insertion.After(__sibling_last.id, request.responseText);
								if (callback) callback();
							}
						}
					);
					*/
					if (callback) callback();
				}
			}
		}
	);
}


