#!/usr/env python
# -*- coding: utf-8 -*-
#	Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	http://vee.kldp.net
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import i18n

_ = i18n.gettext()

import sys, os, time, xmlrpclib
sys.path = ["/usr/local/lib/python/2.3/lib/python2.3/site-packages", ] + sys.path

try :
	import gconf
	import Options, GConf, Conf, func, SSHClient
	from twisted.python import usage
except :
	raise ImportError, \
_("""This program requires these modules,
  - sys
  - os
  - gconf
  - time
  - xmlrpclib and,
  - vee modulees.
  - twisted (>= 2.0)

And you need to install python-gnome2 and pygtk and GTKv2 and Twisted Framework.""")

# parse command-line argument.
options = Options.SSHClient()

args = sys.argv[1:]
if '-l' in args : # cvs is an idiot
	i = args.index('-l')
	args = args[i:i+2]+args
	del args[i+2:i+4]

for arg in args[:] :
	try:
		i = args.index(arg)
		if arg[:2] == '-o' and args[i+1][0]!='-' :
			args[i:i+2] = [] # suck on it scp
	except ValueError :
		pass

try:
	options.parseOptions(args)
except usage.UsageError, u:
	print options.opt_help()
	sys.exit(1)

if not options["host"].strip() and not options["uid"].strip() :
	print options.opt_help()
	sys.exit(1)

import SSHClient

R = SSHClient.Run(**options)
R.run()


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "sshclient.py"


