# -*- coding: utf-8 -*-
#	Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	http://vee.kldp.net
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from optparse import OptionParser

from vee import Conf__, Conf, i18n
_ = i18n.gettext()

def __OPTIONS__ (options, usage, version="%prog 1.0") :
	parser = OptionParser(version=version)

	parser.usage = usage

	for i, j in options.items() :
		parser.add_option(i, j[0], **j[1])

	return parser

def VEE () :
	version = "%%prog %s" % Conf__.INFO["version"]
	usage = "%prog [options]"
	return __OPTIONS__(Conf.OPTIONS_VEE, usage, version)

def VEET () :
	version = "%prog 1.0"
	usage = "%prog [options]"
	return __OPTIONS__(Conf.OPTIONS_VEET, usage, version)

def parse_argument_of_veet (data) :
	__a = xmlrpclib.loads(data)

	if len(__a[0]) < 2 :
		__uid = None
	else :
		__uid = __a[0][1]

	__data = __a[0][0][1:]

	return (__uid, __data)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Options.py"


